# TODO
# - skip interfaces check:
#   checking for iface getifaddrs...
#   lo         IP=127.0.0.1 NETMASK=255.0.0.0
#   eth0       IP=x.x.x.x NETMASK=255.255.252.0
# - add support for /sbin/ss instead of /bin/netstat (ss uses kernel netlink
#   which is huge win on server with loads of open tcp sockets)
# - patch scripts for pld
#
# Conditional build:
%bcond_without	ibverbs		# InfiniBand support
%bcond_without	pcp		# Performance Co-Pilot support
#
Summary:	A Clustered Database based on Samba's Trivial Database (TDB)
Summary(pl.UTF-8):	Klastrowa baza danych oparta na bazie danych Trivial Database z Samby (TDB)
Name:		ctdb
Version:	2.5.6
Release:	1
License:	GPL v3+
Group:		Daemons
Source0:	https://www.samba.org/ftp/ctdb/%{name}-%{version}.tar.gz
# Source0-md5:	efc50109f90a4c790124c35e4ba234ad
Patch0:		%{name}-format.patch
URL:		http://ctdb.samba.org/
%{?with_pcp:BuildRequires:	pcp-devel}
BuildRequires:	popt-devel
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRequires:	talloc-devel
BuildRequires:	tdb-devel
BuildRequires:	tevent-devel
%if %{with ibverbs}
BuildRequires:	libibverbs-devel
BuildRequires:	librdmacm-devel
%endif
Requires(post,preun):	/sbin/chkconfig
Requires:	coreutils
Requires:	psmisc
Requires:	rc-scripts
Requires:	sed
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
CTDB is a cluster implementation of the TDB database used by Samba and
other projects to store temporary data. If an application is already
using TDB for temporary data it is very easy to convert that
application to be cluster aware and use CTDB instead.

%description -l pl.UTF-8
CTDB to klastrowa implementacja bazy danych TDB używanej w Sambie oraz
innych projektach do przechowywania danych tymczasowych. Jeśli jakaś
aplikacja już wykorzystuje TDB do trzymania danych tymczasowych,
bardzo przerobić ją na klastrowalną, wykorzystującą CTDB.

%package devel
Summary:	CTDB clustered database development package
Summary(pl.UTF-8):	Pakiet programistyczny klastrowej bazy danych CTDB
Group:		Development/Libraries
Requires:	tdb-devel
# does not require base

%description devel
Header files etc. you can use to develop CTDB applications.

%description devel -l pl.UTF-8
Pliki nagłówkowe i inne, przy użyciu których można tworzyć aplikacje
wykorzystujące CTDB.

%package -n pcp-ctdb
Summary:	CTDB PMDA
Summary(pl.UTF-8):	PMDA CTDB
Group:		Applications/System
Requires:	%{name} = %{version}-%{release}
Requires:	pcp

%description -n pcp-ctdb
This PMDA extracts metrics from the locally running ctdbd daemon for
export to PMCD.

%description -n pcp-ctdb -l pl.UTF-8
Ten PMDA odczytuje pomiary z lokalnie działającego demona ctdbd w celu
wyeksportowania do PMCD.

%prep
%setup -q
%patch0 -p1

%build
%configure \
	%{?with_pcp:--enable-pmda} \
	%{?with_ibverbs:--enable-infiniband}
%{__make} showflags
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/etc/{sysconfig,rc.d/init.d},%{systemdunitdir}}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

cp -a config/ctdb.sysconfig $RPM_BUILD_ROOT/etc/sysconfig/ctdb
install -p config/ctdb.init $RPM_BUILD_ROOT/etc/rc.d/init.d/ctdb
cp -p config/ctdb.service $RPM_BUILD_ROOT%{systemdunitdir}
install -d $RPM_BUILD_ROOT%{systemdtmpfilesdir}
cat >$RPM_BUILD_ROOT%{systemdtmpfilesdir}/ctdb.conf <<EOF
d /var/run/ctdb 0755 root root -
EOF

install -d $RPM_BUILD_ROOT%{_docdir}/ctdb/tests/bin
install -p tests/bin/ctdb_transaction $RPM_BUILD_ROOT%{_docdir}/ctdb/tests/bin

# Remove "*.old" files
find $RPM_BUILD_ROOT -name "*.old" -exec rm -fv {} ';'

# fix doc path
mv $RPM_BUILD_ROOT%{_docdir}/ctdb $RPM_BUILD_ROOT%{_docdir}/ctdb-%{version}
cp -a web $RPM_BUILD_ROOT%{_docdir}/ctdb-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add ctdb
%service ctdb restart

%preun
if [ "$1" -eq "0" ] ; then
	%service ctdb stop
	/sbin/chkconfig --del ctdb
fi

%files
%defattr(644,root,root,755)
%{_docdir}/ctdb-%{version}
%dir %{_sysconfdir}/ctdb
%{_sysconfdir}/ctdb/events.d
%{_sysconfdir}/ctdb/nfs-rpc-checks.d
%{_sysconfdir}/ctdb/notify.d
%config(noreplace) %verify(not md5 mtime size) %attr(755,root,root) %{_sysconfdir}/ctdb/ctdb-crash-cleanup.sh
%config(noreplace) %verify(not md5 mtime size) %attr(755,root,root) %{_sysconfdir}/ctdb/debug-hung-script.sh
%config(noreplace) %verify(not md5 mtime size) %attr(755,root,root) %{_sysconfdir}/ctdb/debug_locks.sh
%config(noreplace) %verify(not md5 mtime size) %attr(755,root,root) %{_sysconfdir}/ctdb/gcore_trace.sh
%config(noreplace) %verify(not md5 mtime size) %attr(755,root,root) %{_sysconfdir}/ctdb/notify.sh
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/ctdb/functions
%{_sysconfdir}/ctdb/statd-callout
%attr(755,root,root) %{_sbindir}/ctdbd
%attr(755,root,root) %{_sbindir}/ctdbd_wrapper
%attr(755,root,root) %{_bindir}/ctdb
%attr(755,root,root) %{_bindir}/ctdb_diagnostics
%attr(755,root,root) %{_bindir}/ctdb_event_helper
%attr(755,root,root) %{_bindir}/ctdb_lock_helper
%attr(755,root,root) %{_bindir}/ltdbtool
%attr(755,root,root) %{_bindir}/onnode
%attr(755,root,root) %{_bindir}/ping_pong
%attr(755,root,root) %{_bindir}/smnotify
%{systemdunitdir}/ctdb.service
%{systemdtmpfilesdir}/ctdb.conf
%attr(754,root,root) /etc/rc.d/init.d/ctdb
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/ctdb
%attr(440,root,root) /etc/sudoers.d/ctdb
%dir /var/run/ctdb
%{_mandir}/man1/ctdb.1*
%{_mandir}/man1/ctdbd.1*
%{_mandir}/man1/ctdbd_wrapper.1*
%{_mandir}/man1/ltdbtool.1*
%{_mandir}/man1/onnode.1*
%{_mandir}/man1/ping_pong.1*
%{_mandir}/man5/ctdbd.conf.5*
%{_mandir}/man7/ctdb.7*
%{_mandir}/man7/ctdb-statistics.7*
%{_mandir}/man7/ctdb-tunables.7*

%files devel
%defattr(644,root,root,755)
%{_includedir}/ctdb*.h
%{_pkgconfigdir}/ctdb.pc

%files -n pcp-ctdb
%defattr(644,root,root,755)
%dir /var/lib/pcp/pmdas/ctdb
%doc /var/lib/pcp/pmdas/ctdb/README
%attr(755,root,root) /var/lib/pcp/pmdas/ctdb/Install
%attr(755,root,root) /var/lib/pcp/pmdas/ctdb/Remove
%attr(755,root,root) /var/lib/pcp/pmdas/ctdb/pmdactdb
/var/lib/pcp/pmdas/ctdb/domain.h
/var/lib/pcp/pmdas/ctdb/help
/var/lib/pcp/pmdas/ctdb/pmns
%changelog
* Sat May 21 2016 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ctdb.git;a=log;h=master

* Sat May 21 2016 Jakub Bogusz <qboosh@pld-linux.org> 34ee3b4
- updated to 2.5.6

* Wed May 20 2015 Jakub Bogusz <qboosh@pld-linux.org> b57de2c
- updated to 2.5.5

* Tue Feb 24 2015 Jan Rękorajski <baggins@pld-linux.org> 9b2cb4e
- x32 rebuild
- release 2 (by relup.sh)

* Sun Nov 02 2014 Jakub Bogusz <qboosh@pld-linux.org> 7f6e7f7
- updated to 2.5.4
- removed obsolete ib patch

* Fri Apr 04 2014 Jakub Bogusz <qboosh@pld-linux.org> cf46922
- updated to 2.5.3

* Sun Feb 09 2014 Jakub Bogusz <qboosh@pld-linux.org> f17fecd
- updated to 2.5.2

* Mon Dec 23 2013 Jakub Bogusz <qboosh@pld-linux.org> 75f2487
- updated to 2.5.1

* Sat Nov 02 2013 Jakub Bogusz <qboosh@pld-linux.org> d8b3975
- updated to 2.5

* Fri Aug 30 2013 Jakub Bogusz <qboosh@pld-linux.org> 76796c3
- updated to 2.4

* Sun Jul 14 2013 Jakub Bogusz <qboosh@pld-linux.org> 34bdfca
- package systemd file

* Sun Jul 14 2013 Jakub Bogusz <qboosh@pld-linux.org> fc43d07
- updated to 2.3
- updated ib patch

* Fri Jun 07 2013 Jakub Bogusz <qboosh@pld-linux.org> b14063e
- updated to 2.2
- updated ib patch, removed obsolete pcp patch

* Sun Jan 20 2013 Jakub Bogusz <qboosh@pld-linux.org> 5845d26
- added format patch (fixes build with -Werror=format-security)

* Sat Jan 19 2013 Jakub Bogusz <qboosh@pld-linux.org> 75fdf15
- updated to 2.1

* Sat Dec 22 2012 Jakub Bogusz <qboosh@pld-linux.org> 2aadb1b
- build pcp agent (PMDA)
- added pcp patch (build fixes for it)

* Mon Dec 17 2012 Jakub Bogusz <qboosh@pld-linux.org> 2e30401
- restored netstat todo (it seems that there are still some netstat uses, even though configure checks are no longer)

* Sun Dec 16 2012 Jakub Bogusz <qboosh@pld-linux.org> 8eca7ff
- updated to 2.0
- removed obsolete version patch
- added ib patch (fixes build of InfiniBand support)

* Tue Feb 14 2012 Jakub Bogusz <qboosh@pld-linux.org> c63e09a
- added version patch to fix generating pkgconfig() Provides
- release 2

* Mon Feb 13 2012 Jakub Bogusz <qboosh@pld-linux.org> 12c08eb
- pl
- BR: popt-devel

* Thu Mar 18 2010 Elan Ruusamäe <glen@pld-linux.org> 1401040
- no reason why -devel would require base; rel 1

